// Matrix program
// RjY/anARCHy

#include <stdio.h>
#include <stdlib.h>

#include "matrix.h"

int main(int argc, char *argv[]) {
	Matrix *M, *N, *P;
	Real det;
	int MN, i, j;

	if (argc < 2 || (MN = atoi(argv[1])) < 1 || argc != (2 + MN*MN)) {
		fprintf(stderr, "Syntax: %s <N> <N*N m_ij>\n", argv[0]);
		exit(1);
	}

	M = matrix_new(MN);

	for (i = 0; i < MN; i++) for (j = 0; j < MN; j++)
		matrix_set_elt(M, i, j, atof(argv[2+MN*i+j]));

	printf("Let M be the matrix\n");
	matrix_print(M);

	det = matrix_det(M);
	printf("with determinant %f\n\n", det);
	
	if (!(N = matrix_invert(M)))
		printf("M is not invertible\n");
	else {
		printf("Therefore M has inverse N\n");
		matrix_print(N);

		printf("\nCheck that MN is the identity: MN = \n");
		P = matrix_mult(M, N);
		matrix_print(P);

		matrix_free(P);
		matrix_free(N);
	}

	matrix_free(M);

	return 0;
}
